'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChartView = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recharts = require('recharts');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ChartView = exports.ChartView = function (_React$Component) {
  _inherits(ChartView, _React$Component);

  function ChartView(props) {
    _classCallCheck(this, ChartView);

    var _this = _possibleConstructorReturn(this, (ChartView.__proto__ || Object.getPrototypeOf(ChartView)).call(this, props));

    _this.chartTypes = ['line', 'area', 'bar'];
    _this.xAxisFields = ['height', 'timestamp'];
    _this.yAxisFields = ['gasUsed', 'gasLimit', 'size', 'gas', 'gasPrice', 'value'];

    _this.handleChartKeyChange = _this.changeChartKey.bind(_this);
    _this.handleChartTypeChange = _this.changeChartType.bind(_this);
    _this.handleYAxisFieldChange = _this.changeYAxisField.bind(_this);

    var data = _this.getChartData(_this.props.value);
    _this.state = Object.assign({ chartType: 'line', chartWidth: 640, chartHeight: 320 }, _this.getChartState(data));
    return _this;
  }

  _createClass(ChartView, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.value !== nextProps.value) {
        this.setState(this.getChartState(this.getChartData(nextProps.value)));
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return this.props.value !== nextProps.value;
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          chartType = _state.chartType,
          chartKeys = _state.chartKeys,
          chartKey = _state.chartKey,
          xAxisField = _state.xAxisField,
          yAxisFields = _state.yAxisFields,
          yAxisField = _state.yAxisField,
          chartData = _state.chartData;
      var chartTypes = this.chartTypes;


      return _react2.default.createElement(
        'div',
        { className: 'result-window result-window-chart' },
        chartKeys.length === 0 && _react2.default.createElement(
          'p',
          null,
          'No data for charting available, currently',
          ' ',
          this.yAxisFields.join('/'),
          ' fields are supported'
        ),
        chartKeys.length > 0 && _react2.default.createElement(
          'div',
          { className: 'chart-container' },
          _react2.default.createElement(
            'div',
            { className: 'chart-config' },
            this.renderFormControl({
              label: 'Entity',
              handler: this.handleChartKeyChange,
              options: chartKeys,
              value: chartKey
            }),
            this.renderFormControl({
              label: 'Chart Type',
              handler: this.handleChartTypeChange,
              options: chartTypes,
              value: chartType
            }),
            this.renderFormControl({
              label: 'Display Field',
              handler: this.handleYAxisFieldChange,
              options: yAxisFields,
              value: yAxisField
            })
          ),
          _react2.default.createElement(
            'div',
            {
              className: 'chart-view',
              key: chartType + '-' + chartKey + '-' + xAxisField + '-' + yAxisField },
            chartType === 'line' && this.renderLineChart(chartKey, xAxisField, yAxisField, chartData),
            chartType === 'area' && this.renderAreaChart(chartKey, xAxisField, yAxisField, chartData),
            chartType === 'bar' && this.renderBarChart(chartKey, xAxisField, yAxisField, chartData)
          )
        )
      );
    }
  }, {
    key: 'renderFormControl',
    value: function renderFormControl(_ref) {
      var label = _ref.label,
          handler = _ref.handler,
          options = _ref.options,
          value = _ref.value;

      return _react2.default.createElement(
        'label',
        { className: 'chart-form-control' },
        label,
        _react2.default.createElement(
          'select',
          { onChange: handler },
          options.map(function (x) {
            return _react2.default.createElement(
              'option',
              { key: x, value: x, defaultValue: value === x },
              x
            );
          })
        )
      );
    }
  }, {
    key: 'renderLineChart',
    value: function renderLineChart(chartKey, xAxisField, yAxisField, chartData) {
      var _state2 = this.state,
          chartWidth = _state2.chartWidth,
          chartHeight = _state2.chartHeight;

      return _react2.default.createElement(
        _recharts.LineChart,
        {
          width: chartWidth,
          height: chartHeight,
          data: chartData,
          margin: { top: 30, right: 0, left: 5, bottom: 30 } },
        _react2.default.createElement(_recharts.XAxis, { dataKey: xAxisField }),
        _react2.default.createElement(_recharts.YAxis, null),
        _react2.default.createElement(_recharts.CartesianGrid, { strokeDasharray: '3 3' }),
        _react2.default.createElement(_recharts.Tooltip, null),
        _react2.default.createElement(_recharts.Legend, null),
        _react2.default.createElement(_recharts.Line, {
          type: 'monotone',
          dataKey: yAxisField,
          stroke: '#8884d8',
          dot: { r: 2 },
          activeDot: { r: 3 }
        })
      );
    }
  }, {
    key: 'renderAreaChart',
    value: function renderAreaChart(chartKey, xAxisField, yAxisField, chartData) {
      var _state3 = this.state,
          chartWidth = _state3.chartWidth,
          chartHeight = _state3.chartHeight;

      return _react2.default.createElement(
        _recharts.AreaChart,
        {
          width: chartWidth,
          height: chartHeight,
          data: chartData,
          margin: { top: 30, right: 0, left: 5, bottom: 30 } },
        _react2.default.createElement(_recharts.XAxis, { dataKey: xAxisField }),
        _react2.default.createElement(_recharts.YAxis, null),
        _react2.default.createElement(_recharts.CartesianGrid, { strokeDasharray: '3 3' }),
        _react2.default.createElement(_recharts.Tooltip, null),
        _react2.default.createElement(_recharts.Legend, null),
        _react2.default.createElement(_recharts.Area, {
          type: 'monotone',
          dataKey: yAxisField,
          stroke: '#8884d8',
          dot: { r: 2 },
          activeDot: { stroke: '#0088FF', r: 3 }
        })
      );
    }
  }, {
    key: 'renderBarChart',
    value: function renderBarChart(chartKey, xAxisField, yAxisField, chartData) {
      var _state4 = this.state,
          chartWidth = _state4.chartWidth,
          chartHeight = _state4.chartHeight;

      return _react2.default.createElement(
        _recharts.BarChart,
        {
          width: chartWidth,
          height: chartHeight,
          data: chartData,
          margin: { top: 30, right: 0, left: 5, bottom: 30 } },
        _react2.default.createElement(_recharts.XAxis, { dataKey: xAxisField }),
        _react2.default.createElement(_recharts.YAxis, null),
        _react2.default.createElement(_recharts.CartesianGrid, { strokeDasharray: '3 3' }),
        _react2.default.createElement(_recharts.Tooltip, null),
        _react2.default.createElement(_recharts.Legend, null),
        _react2.default.createElement(_recharts.Bar, { type: 'monotone', dataKey: yAxisField })
      );
    }
  }, {
    key: 'changeChartKey',
    value: function changeChartKey(e) {
      var chartKey = e.target.value;
      if (this.state.chartKey === chartKey) {
        return;
      }

      this.setState(this.getChartState(this.getChartData(this.props.value), chartKey));
    }
  }, {
    key: 'changeChartType',
    value: function changeChartType(e) {
      var _this2 = this;

      var chartType = e.target.value;
      if (this.state.chartType === chartType) {
        return;
      }

      this.setState({ chartType: chartType }, function () {
        _this2.forceUpdate();
      });
    }
  }, {
    key: 'changeYAxisField',
    value: function changeYAxisField(e) {
      var _this3 = this;

      var yAxisField = e.target.value;
      if (this.state.yAxisField === yAxisField) {
        return;
      }
      if (this.state.yAxisFields.includes(yAxisField)) {
        this.setState({ yAxisField: yAxisField }, function () {
          _this3.forceUpdate();
        });
      }
    }
  }, {
    key: 'getChartState',
    value: function getChartState(items, key) {
      var chartKeys = [];
      var chartKey = '';
      var xAxisField = '';
      var yAxisFields = [];
      var yAxisField = '';
      var chartData = [];

      if (items.length) {
        chartKeys = items.map(function (x) {
          return x.key;
        });
        chartKey = key !== undefined ? key : chartKeys[0];

        var entry = items[key !== undefined ? chartKeys.indexOf(key) : 0];
        xAxisField = entry.xAxisField;
        yAxisFields = entry.yAxisFields;
        yAxisField = yAxisFields[0];
        chartData = entry.data;
      }

      return {
        chartKeys: chartKeys,
        chartKey: chartKey,
        xAxisField: xAxisField,
        yAxisFields: yAxisFields,
        yAxisField: yAxisField,
        chartData: chartData
      };
    }
  }, {
    key: 'getChartData',
    value: function getChartData(value) {
      var _this4 = this;

      if (!value) {
        return [];
      }

      try {
        var res = JSON.parse(value);
        return Object.keys(res.data).filter(function (x) {
          return Array.isArray(res.data[x]);
        }).map(function (x) {
          return {
            key: x,
            data: res.data[x]
          };
        }).map(function (x) {
          if (!x.data.length) {
            return x;
          }

          var fields = Object.keys(x.data[0]);
          x.xAxisField = fields.find(function (f) {
            return _this4.xAxisFields.includes(f);
          });
          x.yAxisFields = fields.filter(function (f) {
            return _this4.yAxisFields.includes(f);
          });

          return x;
        }).filter(function (x) {
          return x.data.length > 0 && x.xAxisField && x.yAxisFields.length;
        });
      } catch (err) {
        console.error('ChartView.error', err);
        return [];
      }
    }
  }]);

  return ChartView;
}(_react2.default.Component);

ChartView.propTypes = {
  value: _propTypes2.default.string,
  editorTheme: _propTypes2.default.string
};