'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableView = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TableView = exports.TableView = function (_React$Component) {
  _inherits(TableView, _React$Component);

  function TableView() {
    _classCallCheck(this, TableView);

    return _possibleConstructorReturn(this, (TableView.__proto__ || Object.getPrototypeOf(TableView)).apply(this, arguments));
  }

  _createClass(TableView, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return this.props.value !== nextProps.value;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var dataGroups = this.getDataGroups();
      return _react2.default.createElement(
        'div',
        { className: 'result-window result-window-table' },
        dataGroups.length === 0 && _react2.default.createElement(
          'p',
          null,
          'no table data to display!'
        ),
        dataGroups.map(function (x) {
          return _this2.renderGroup(x);
        })
      );
    }
  }, {
    key: 'renderGroup',
    value: function renderGroup(group) {
      return _react2.default.createElement(
        'div',
        { className: 'table-group', key: 'table-group-' + group.title },
        _react2.default.createElement(
          'h3',
          { className: 'table-group-title' },
          group.title
        ),
        _react2.default.createElement(
          'table',
          { className: 'table-group-body' },
          _react2.default.createElement(
            'thead',
            null,
            _react2.default.createElement(
              'tr',
              null,
              group.headers.map(function (key) {
                return _react2.default.createElement(
                  'th',
                  { key: key },
                  key.toUpperCase()
                );
              })
            )
          ),
          _react2.default.createElement(
            'tbody',
            null,
            group.entries.map(function (entry, i) {
              return _react2.default.createElement(
                'tr',
                { key: 'entry-' + i },
                group.headers.map(function (key) {
                  return _react2.default.createElement(
                    'td',
                    { key: 'entry-' + i + '-' + key },
                    entry[key].toString()
                  );
                })
              );
            })
          )
        )
      );
    }
  }, {
    key: 'getDataGroups',
    value: function getDataGroups() {
      if (!this.props.value) {
        return [];
      }

      try {
        var res = JSON.parse(this.props.value);
        return Object.keys(res.data).filter(function (x) {
          return Array.isArray(res.data[x]);
        }).map(function (x) {
          return {
            title: x,
            entries: res.data[x]
          };
        }).filter(function (x) {
          return x.entries.length > 0;
        }).map(function (x) {
          // assume all data entry are of the same shape
          x.headers = Object.keys(x.entries[0]);
          return x;
        });
      } catch (err) {
        console.error('TableView.error', err);
        return [];
      }
    }
  }]);

  return TableView;
}(_react2.default.Component);

TableView.propTypes = {
  value: _propTypes2.default.string,
  editorTheme: _propTypes2.default.string
};