'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ResultViewer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _JsonView = require('./JsonView');

var _TableView = require('./TableView');

var _ChartView = require('./ChartView');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FakeCodeMirror = {
  setSize: function setSize() {},
  setValue: function setValue() {},
  refresh: function refresh() {}
};

var ResultViewer = exports.ResultViewer = function (_React$Component) {
  _inherits(ResultViewer, _React$Component);

  function ResultViewer(props) {
    _classCallCheck(this, ResultViewer);

    var _this = _possibleConstructorReturn(this, (ResultViewer.__proto__ || Object.getPrototypeOf(ResultViewer)).call(this, props));

    _this.state = {
      mode: _this.props.storage.get('resultViewerMode') || 'json'
    };
    return _this;
  }

  _createClass(ResultViewer, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.viewRender && this.viewRender.codeMirror) {
        this.viewRender.codeMirror.setValue(this.props.value || '');
      }
      this.props.storage.set('resultViewerMode', this.state.mode);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.viewRender.codeMirror = null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var mode = this.state.mode;

      var ViewRenderer = this.getViewRender(mode);

      return _react2.default.createElement(
        'div',
        {
          className: 'result-container',
          ref: function ref(node) {
            _this2._node = node;
          } },
        _react2.default.createElement(
          'div',
          { className: 'mode-switcher' },
          _react2.default.createElement(
            'div',
            {
              className: this.getButtonClass('json'),
              onClick: function onClick() {
                return _this2.switchMode('json');
              } },
            'JSON'
          ),
          _react2.default.createElement(
            'div',
            {
              className: this.getButtonClass('table'),
              onClick: function onClick() {
                return _this2.switchMode('table');
              } },
            'Table'
          ),
          _react2.default.createElement(
            'div',
            {
              className: this.getButtonClass('chart'),
              onClick: function onClick() {
                return _this2.switchMode('chart');
              } },
            'Chart'
          )
        ),
        _react2.default.createElement(ViewRenderer, {
          ref: function ref(c) {
            _this2.viewRender = c;
          },
          value: this.props.value,
          editorTheme: this.props.editorTheme,
          ResultsTooltip: this.props.ResultsTooltip
        })
      );
    }
  }, {
    key: 'switchMode',
    value: function switchMode(mode) {
      this.setState({ mode: mode });
    }
  }, {
    key: 'getViewRender',
    value: function getViewRender(mode) {
      return {
        json: _JsonView.JsonView,
        table: _TableView.TableView,
        chart: _ChartView.ChartView
      }[mode];
    }
  }, {
    key: 'getButtonClass',
    value: function getButtonClass(mode) {
      return ('button ' + (this.state.mode === mode ? 'button-active' : '')).trim();
    }

    /**
     * Public API for retrieving the CodeMirror instance from this
     * React component.
     */

  }, {
    key: 'getCodeMirror',
    value: function getCodeMirror() {
      return this.viewRender && this.viewRender.codeMirror ? this.viewRender.codeMirror : FakeCodeMirror;
    }

    /**
     * Public API for retrieving the DOM client height for this component.
     */

  }, {
    key: 'getClientHeight',
    value: function getClientHeight() {
      return this._node && this._node.clientHeight;
    }
  }]);

  return ResultViewer;
}(_react2.default.Component);

ResultViewer.propTypes = {
  storage: _propTypes2.default.object.isRequired,
  value: _propTypes2.default.string,
  editorTheme: _propTypes2.default.string,
  ResultsTooltip: _propTypes2.default.any
};